# -*- coding: utf-8 -*-
# @Time    : 2022/9/20 9:05
# @Author  : ZAOXG
# @File    : condition_filter.py

import data_process_tool
import pandas as pd


def get_filter(text):
    text_list = text.split('; ')
    for t in text_list:
        t.index()


def method1(table):
    table_name = None
    if isinstance(table, str):
        table_name = str(table)
        table = data_process_tool.read_data(table)
    # 只保留唯一id列 UT, 发文地址列 C1
    # 讲地址列以';'分割, 筛选符合条件的行, 获取符合条件的id
    # 原始表匹配符合条件的行, 保存匹配出结果的行
    new_table = table[['UT', 'C1']]
    new_table.rename(columns={'UT': 'UT-BP'}, inplace=True)
    locations = table['C1'].str.split('; ', expand=True)
    locations = locations.stack()
    locations = locations.reset_index(level=1, drop=True)
    locations.name = 'LOCATION'
    new_table = new_table.drop(['C1'], axis=1).join(locations)
    new_table['LOCATION'] = new_table['LOCATION'].str.lower()
    print(new_table)
    # univ petr|petr univ|unit petr|univj petr 条件由wos检索策略来的
    # 筛选华东
    hd: pd.DataFrame = new_table[(new_table['LOCATION'].str.contains('univ petr|petr univ|unit petr|univj petr')) & (new_table['LOCATION'].str.contains('shandong|qingdao|dongying'))]
    del hd['LOCATION']
    hd.drop_duplicates(subset=['UT-BP'], inplace=True)
    hd = pd.merge(table, hd, 'left', left_on=['UT'], right_on=['UT-BP'])
    hd = hd[hd['UT-BP'].notnull()]
    del hd['UT-BP']
    hd.to_excel(table_name.replace('.xlsx', '-华东.xlsx'), index=False)
    # 筛选北京
    bj: pd.DataFrame = new_table[(new_table['LOCATION'].str.contains('univ petr|petr univ|unit petr|univj petr')) & (new_table['LOCATION'].str.contains('beijing'))]
    del bj['LOCATION']
    bj.drop_duplicates(subset=['UT-BP'], inplace=True)
    bj = pd.merge(table, bj, 'left', left_on=['UT'], right_on=['UT-BP'])
    bj = bj[bj['UT-BP'].notnull()]
    del bj['UT-BP']
    bj.to_excel(table_name.replace('.xlsx', '-北京.xlsx'), index=False)


def condition_filter(table, filters: list = None):
    table_name = None
    if isinstance(table, str):
        table_name = str(table)
        table = data_process_tool.read_data(table)
    table['C1_BP'] = table['C1'].str.lower()
    hd = table[(table['C1_BP'].str.contains('shandong')) | (table['C1_BP'].str.contains('qingdao')) | (table['C1_BP'].str.contains('dongying'))]
    del hd['C1_BP']
    hd.to_excel(table_name.replace('.xlsx', '华东.xlsx'), index=False)
    bj = table[(table['C1_BP'].str.contains('beijing'))]
    del bj['C1_BP']
    bj.to_excel(table_name.replace('.xlsx', '北京.xlsx'), index=False)


if __name__ == '__main__':
    # condition_filter(r'F:\工作数据存储2022\20220919_中国石油大学wos\2020.xlsx')
    method1(r'Z:\客户数据存储\WOS\中国石油大学\OG=(China University of Petroleum) AND (PY==(2022))\OG=(China University of Petroleum) AND (PY==(2022)).xlsx')
